GDCM: gdcm::JPEG2000Codec Class Reference

GDCM 3.2.7

Public Member Functions | Protected Member Functions | Friends | List of all members
gdcm::JPEG2000Codec Class Reference

Class to do JPEG 2000. More...

`#include <gdcmJPEG2000Codec.h>`

Inheritance diagram for gdcm::JPEG2000Codec:
[legend]
Collaboration diagram for gdcm::JPEG2000Codec:
[legend]

## Public Member Functions
| JPEG2000Codec ()
| ~JPEG2000Codec () override
bool | CanCode (TransferSyntax const &ts) const override
| Return whether this coder support this transfer syntax (can code it).
bool | CanDecode (TransferSyntax const &ts) const override
| Return whether this decoder support this transfer syntax (can decode it).
ImageCodec * | Clone () const override
bool | Code (DataElement const &in, DataElement &out) override
| Code.
bool | Decode (DataElement const &is, DataElement &os) override
| Decode.
bool | GetHeaderInfo (std::istream &is, TransferSyntax &ts) override
double | GetQuality (unsigned int idx=0) const
double | GetRate (unsigned int idx=0) const
void | SetMCT (unsigned int mct)
void | SetNumberOfResolutions (unsigned int nres)
void | SetNumberOfThreadsForDecompression (int nThreads)
void | SetQuality (unsigned int idx, double q)
void | SetRate (unsigned int idx, double rate)
void | SetReversible (bool res)
void | SetTileSize (unsigned int tx, unsigned int ty)
Public Member Functions inherited from gdcm::ImageCodec
| ImageCodec ()
| ~ImageCodec () override
bool | CleanupUnusedBits (char *data, size_t datalen)
const unsigned int * | GetDimensions () const
bool | GetLossyFlag () const
const LookupTable & | GetLUT () const
bool | GetNeedByteSwap () const
unsigned int | GetNumberOfDimensions () const
const PhotometricInterpretation & | GetPhotometricInterpretation () const
PixelFormat & | GetPixelFormat ()
const PixelFormat & | GetPixelFormat () const
unsigned int | GetPlanarConfiguration () const
bool | IsLossy () const
void | SetDimensions (const std::vector< unsigned int > &d)
void | SetDimensions (const unsigned int d[3])
void | SetLossyFlag (bool l)
void | SetLUT (LookupTable const &lut)
void | SetNeedByteSwap (bool b)
void | SetNeedOverlayCleanup (bool b)
void | SetNumberOfDimensions (unsigned int dim)
void | SetPhotometricInterpretation (PhotometricInterpretation const &pi)
virtual void | SetPixelFormat (PixelFormat const &pf)
void | SetPlanarConfiguration (unsigned int pc)
Public Member Functions inherited from gdcm::Coder
virtual | ~Coder ()=default
Public Member Functions inherited from gdcm::Decoder
virtual | ~Decoder ()=default

## Protected Member Functions
bool | AppendFrameEncode (std::ostream &out, const char *data, size_t datalen) override
bool | AppendRowEncode (std::ostream &out, const char *data, size_t datalen) override
bool | DecodeByStreams (std::istream &is, std::ostream &os) override
bool | DecodeExtent (char *buffer, unsigned int xmin, unsigned int xmax, unsigned int ymin, unsigned int ymax, unsigned int zmin, unsigned int zmax, std::istream &is)
bool | IsFrameEncoder () override
bool | IsRowEncoder () override
bool | StartEncode (std::ostream &) override
bool | StopEncode (std::ostream &) override
Protected Member Functions inherited from gdcm::ImageCodec
bool | DoByteSwap (std::istream &is_, std::ostream &os)
bool | DoInvertMonochrome (std::istream &is_, std::ostream &os)
bool | DoOverlayCleanup (std::istream &is_, std::ostream &os)
bool | DoPaddedCompositePixelCode (std::istream &is_, std::ostream &os)
bool | DoPlanarConfiguration (std::istream &is_, std::ostream &os)
bool | DoSimpleCopy (std::istream &is_, std::ostream &os)
bool | DoYBR (std::istream &is_, std::ostream &os)
bool | DoYBRFull422 (std::istream &is_, std::ostream &os)
virtual bool | IsValid (PhotometricInterpretation const &pi)
Protected Member Functions inherited from gdcm::Coder
virtual bool | InternalCode (const char *bv, unsigned long len, std::ostream &os)

## Friends
class | Bitmap
class | ImageRegionReader

## Additional Inherited Members
Protected Types inherited from gdcm::ImageCodec
typedef SmartPointer< LookupTable > | LUTPtr
Protected Attributes inherited from gdcm::ImageCodec
unsigned int | Dimensions [3]
bool | LossyFlag
LUTPtr | LUT
bool | NeedByteSwap
bool | NeedOverlayCleanup
unsigned int | NumberOfDimensions
PixelFormat | PF
PhotometricInterpretation | PI
unsigned int | PlanarConfiguration
bool | RequestPaddedCompositePixelCode
bool | RequestPlanarConfiguration

## Detailed Description

Class to do JPEG 2000.

Note
  the class will produce JPC (JPEG 2000 codestream), since some private implementor are using full jp2 file the decoder tolerate jp2 input this is an implementation of an ImageCodec

## Constructor & Destructor Documentation

## ◆ JPEG2000Codec()

gdcm::JPEG2000Codec::JPEG2000Codec | ( |  | ) |

## ◆ ~JPEG2000Codec()

gdcm::JPEG2000Codec::~JPEG2000Codec | ( |  | ) |
| override

## Member Function Documentation

## ◆ AppendFrameEncode()

bool gdcm::JPEG2000Codec::AppendFrameEncode | ( | std::ostream & | out,
|  | const char * | data,
|  | size_t | datalen )
| overrideprotectedvirtual

Reimplemented from gdcm::ImageCodec.

## ◆ AppendRowEncode()

bool gdcm::JPEG2000Codec::AppendRowEncode | ( | std::ostream & | out,
|  | const char * | data,
|  | size_t | datalen )
| overrideprotectedvirtual

Reimplemented from gdcm::ImageCodec.

## ◆ CanCode()

bool gdcm::JPEG2000Codec::CanCode | ( | TransferSyntax const & |  | ) | const
| overridevirtual

Return whether this coder support this transfer syntax (can code it).

Reimplemented from gdcm::ImageCodec.

## ◆ CanDecode()

bool gdcm::JPEG2000Codec::CanDecode | ( | TransferSyntax const & |  | ) | const
| overridevirtual

Return whether this decoder support this transfer syntax (can decode it).

Reimplemented from gdcm::ImageCodec.

## ◆ Clone()

ImageCodec * gdcm::JPEG2000Codec::Clone | ( |  | ) | const
| overridevirtual

Implements gdcm::ImageCodec.

References gdcm::ImageCodec::ImageCodec().

## ◆ Code()

bool gdcm::JPEG2000Codec::Code | ( | DataElement const & | in_,
|  | DataElement & | out_ )
| overridevirtual

Code.

Reimplemented from gdcm::Coder.

## ◆ Decode()

bool gdcm::JPEG2000Codec::Decode | ( | DataElement const & | ,
|  | DataElement & | )
| overridevirtual

Decode.

Reimplemented from gdcm::ImageCodec.

## ◆ DecodeByStreams()

bool gdcm::JPEG2000Codec::DecodeByStreams | ( | std::istream & | is,
|  | std::ostream & | os )
| overrideprotectedvirtual

Reimplemented from gdcm::ImageCodec.

## ◆ DecodeExtent()

bool gdcm::JPEG2000Codec::DecodeExtent | ( | char * | buffer,
|  | unsigned int | xmin,
|  | unsigned int | xmax,
|  | unsigned int | ymin,
|  | unsigned int | ymax,
|  | unsigned int | zmin,
|  | unsigned int | zmax,
|  | std::istream & | is )
| protected

## ◆ GetHeaderInfo()

bool gdcm::JPEG2000Codec::GetHeaderInfo | ( | std::istream & | is,
|  | TransferSyntax & | ts )
| overridevirtual

Reimplemented from gdcm::ImageCodec.

Referenced by StopEncode().

## ◆ GetQuality()

double gdcm::JPEG2000Codec::GetQuality | ( | unsigned int | idx = 0 | ) | const

## ◆ GetRate()

double gdcm::JPEG2000Codec::GetRate | ( | unsigned int | idx = 0 | ) | const

## ◆ IsFrameEncoder()

bool gdcm::JPEG2000Codec::IsFrameEncoder | ( |  | ) |
| overrideprotectedvirtual

Reimplemented from gdcm::ImageCodec.

## ◆ IsRowEncoder()

bool gdcm::JPEG2000Codec::IsRowEncoder | ( |  | ) |
| overrideprotectedvirtual

Reimplemented from gdcm::ImageCodec.

## ◆ SetMCT()

void gdcm::JPEG2000Codec::SetMCT | ( | unsigned int | mct | ) |

## ◆ SetNumberOfResolutions()

void gdcm::JPEG2000Codec::SetNumberOfResolutions | ( | unsigned int | nres | ) |

## ◆ SetNumberOfThreadsForDecompression()

void gdcm::JPEG2000Codec::SetNumberOfThreadsForDecompression | ( | int | nThreads | ) |

Set Number of threads

Parameters

  nThreads | : number of threads for decompression codec, if 0 or 1 decompression is done in current thread, if negative value is set determine how many virtual threads are available

## ◆ SetQuality()

void gdcm::JPEG2000Codec::SetQuality | ( | unsigned int | idx,
|  | double | q )

## ◆ SetRate()

void gdcm::JPEG2000Codec::SetRate | ( | unsigned int | idx,
|  | double | rate )

## ◆ SetReversible()

void gdcm::JPEG2000Codec::SetReversible | ( | bool | res | ) |

## ◆ SetTileSize()

void gdcm::JPEG2000Codec::SetTileSize | ( | unsigned int | tx,
|  | unsigned int | ty )

## ◆ StartEncode()

bool gdcm::JPEG2000Codec::StartEncode | ( | std::ostream & |  | ) |
| overrideprotectedvirtual

Reimplemented from gdcm::ImageCodec.

## ◆ StopEncode()

bool gdcm::JPEG2000Codec::StopEncode | ( | std::ostream & |  | ) |
| overrideprotectedvirtual

Reimplemented from gdcm::ImageCodec.

References GetHeaderInfo().

## Friends And Related Symbol Documentation

## ◆ Bitmap

friend class Bitmap
| friend

References Bitmap.

Referenced by Bitmap.

## ◆ ImageRegionReader

friend class ImageRegionReader
| friend

References ImageRegionReader.

Referenced by ImageRegionReader.

The documentation for this class was generated from the following file:

- gdcmJPEG2000Codec.h